
Описание публичного интерфейса библиотеки
==============================
<!-- TOC -->

- [Модуль РаботаСПараметрами:](#модуль-работаспараметрами)
    - [НовыйМенеджерПараметров](#новыйменеджерпараметров)
    - [УстановитьПрефиксКлючаДляЧтенияВложенногоФайлаНастроек](#установитьпрефиксключадлячтениявложенногофайланастроек)
- [Класс МенеджерПараметров:](#класс-менеджерпараметров)
    - [Параметр](#параметр)
    - [ЧтениеВыполнено](#чтениевыполнено)
    - [Прочитать](#прочитать)
    - [УстановитьФайлПараметров](#установитьфайлпараметров)
    - [ДобавитьКаталогПоиска](#добавитькаталогпоиска)
    - [УстановитьИмяФайла](#установитьимяфайла)
    - [УстановитьРасширениеФайла](#установитьрасширениефайла)
    - [УстановитьПараметрыПровайдера](#установитьпараметрыпровайдера)
    - [УстановитьПроизвольныйПровайдерПараметров](#установитьпроизвольныйпровайдерпараметров)
    - [ДобавитьПровайдерПараметров](#добавитьпровайдерпараметров)
    - [ОтключитьПровайдер](#отключитьпровайдер)
    - [ДобавитьВстроенныйПровайдер](#добавитьвстроенныйпровайдер)
    - [УстановитьКлассПриемник](#установитьклассприемник)

<!-- /TOC -->

### Модуль РаботаСПараметрами:
> Общий модуль для работы с параметрами 

#### НовыйМенеджерПараметров
```bsl
// Создает нового менеджера параметров
//
// Параметры:
//   ИмяФайлаПараметров      - Строка - имя файла параметров
//   КаталогПоиск            - Строка - дополнительный каталог поиска параметров
//   Провайдер               - Строка - перечень провайдеров (по умолчанию "json;yaml")
//   КлассПараметров         - Класс  - класс приемник результат чтения параметров
// Возвращаемое значение
//   Класс МенеджерПараметров
//
```

#### УстановитьПрефиксКлючаДляЧтенияВложенногоФайлаНастроек
```bsl
// Устанавливаетпрефикс ключа для чтения вложенных файлов
// (по умолчанию <ReadFile>)
//
// Параметры:
//   НовыйПрефикс - Строка - префикс ключа для чтения вложенных файлов
//
```

### Класс МенеджерПараметров:
> Класс обеспечивающий чтение и запись (в разработке) параметров из провайдеров параметров 

#### Параметр
```bsl
// Устанавливает класс приемник для выгрузки результата чтения параметров
//
// Параметры:
//   ИмяПараметра        - строка - имя параметра
//                                  допустимо указание пути к параметру через точку (например, "config.server.protocol")
//   ЗначениеПоУмолчанию - произвольный - возвращаемое значение в случае отсутствия параметра после чтения
//
// Возвращаемое значение:
//	Произвольный - значение параметра
//
```

#### ЧтениеВыполнено
```bsl
//
// Возвращаемое значение:
//	булево - признак выполнения чтения параметров
//
```

#### Прочитать
```bsl
// Выполняет чтения параметров из доступных провайдеров
//
```

#### УстановитьФайлПараметров
```bsl
// Устанавливает путь к файлу параметров
//
// Параметры:
//   ПутьКФайлу - строка - полный путь к файлу параметров
//
```

#### ДобавитьКаталогПоиска
```bsl
// Добавляет дополнительный путь к каталогу поиска файла параметров
//
// Параметры:
//   ПутьПоискаФайлов - строка - полный путь к дополнительному каталогу для поиска файла параметров
//
```

#### УстановитьИмяФайла
```bsl
// Добавляет имя файла параметров
//
// Параметры:
//   ИмяФайла - строка - имя файла параметров
//
```

#### УстановитьРасширениеФайла
```bsl
// Устанавливает расширение файла параметров
//
// Параметры:
//   РасширениеФайла - строка - расширение файла параметров (например, .json/json)
//
```

#### УстановитьПараметрыПровайдера
```bsl
// Устанавливает параметры для провайдера 
//
// Параметры:
//   ИдентификаторПровайдера - строка - короткий идентификатор провайдера (например, json)
//   Параметры               - структура - произвольная структура для передачи в провайдера
//
```

#### УстановитьПроизвольныйПровайдерПараметров
```bsl
// Очищает таблицу провайдеров и устанавливает произвольный класс-провайдер
//
// Параметры:
//   ИдентификаторПровайдера - строка       - короткий идентификатор провайдера (например, json)
//   Класс                   - Строка/Класс - класс провайдера или имя класса
//   Настройки               - Струтура     - произвольная структура передаваемая провайдеру в момент выполнения
//   Приоритет               - число        - Числовой приоритет выполнения провайдеры (по умолчанию 99)
//
```

#### ДобавитьПровайдерПараметров
```bsl
// Добавляет в таблицу провайдеров произвольный класс-провайдер
//
// Параметры:
//   ИдентификаторПровайдера - строка       - короткий идентификатор провайдера (например, json)
//   Класс                   - Строка/Класс - класс провайдера или имя класса
//   Настройки               - Струтура     - произвольная структура передаваемая провайдеру в момент выполнения
//   Приоритет               - число        - Числовой приоритет выполнения провайдеры (по умолчанию 99)
//
```

#### ОтключитьПровайдер
```bsl
// Отключает и удаляет провайдера из таблицы провайдеров
//
// Параметры:
//   ИдентификаторПровайдера - строка - короткий идентификатор провайдера (например, json)
//
```

#### ДобавитьВстроенныйПровайдер
```bsl
// Добавляет встроенный провайдер по идентификаторы и приоритету
//
// Параметры:
//   ИмяПровайдера - строка - короткий идентификатор встроенных провайдеров (например, json)
//   Приоритет     - число  - Числовой приоритет выполнения провайдеры
//
```

#### УстановитьКлассПриемник
```bsl
// Устанавливает класс приемник для выгрузки результата чтения параметров
//
// Параметры:
//   КлассПараметров - Класс - произвольный класс, реализующий ряд экспортных процедур
//
```